#ifndef AGENT_H_
#define AGENT_H_

#include <string>
#include <vector>
#include <set>

#include "../tcbr/Case.h"
#include "../tcbr/CaseBase.h"
#include "CcbrEngine.h"

using namespace TCBR_Representation;
using namespace std;

namespace CCBR_Module{

	class CcbrEngine;

	class Agent {

	protected:
		CcbrEngine* ccbrEngine_;
		string solutionFeature_;
		int minRank_;

		Case* problem_;
		int dialogueLength_;
		string problemSolution_;

	public:
		Agent(CcbrEngine* ccbrEngine, string solutionFeature, int minRange);
		virtual ~Agent();

		int startSimulation(Case* problem, double problemDescriptionSize);
		pair<string, string> askQuestions(vector<pair<string, double> >* questions);
		Case* askSolutions(vector<pair<Case*, double> >* solutions);

	};
}
#endif /*AGENT_H_*/
