#ifndef CCBRENGINE_H_
#define CCBRENGINE_H_

#include <vector>
#include <string>

#include "Agent.h"
#include "DialogueSystem.h"
#include "InformationGain.h"

#include "../tcbr/Case.h"
#include "../tcbr/CaseBase.h"
#include "../tcbr/SimilarityMeasure.h"
#include "../tcbr/CaseRetriever.h"

using namespace std;
using namespace TCBR_Representation;

namespace CCBR_Module{

	class Agent;
	class DialogueSystem;
	class InformationGain;

	class CcbrEngine {

		protected:
			int queryCounter_;
			CaseBase* casebase_;
			string solutionFeature_;

			set<Entity*> features_;
			DialogueSystem* dialogueSystem_;

			double similarityThreshold_;

			bool dl_;

			vector<pair<string, double> > generateQuestions();
			vector<pair<string, double> > generateQuestions(Case* query, vector<pair<Case*, double> > caseSimilarities);

		public:
			CcbrEngine(CaseBase* casebase, string solutionFeature, double applicationSimThreshold, double dialogueSimThreshold);
			virtual ~CcbrEngine();
			bool query(vector<pair<string, string> > problemDescription, Agent* agent);

			void enableDialogueLearning();
			void disableDialogueLearning();
			int getNumberOfStoredDialogues();
	};

	inline string generateId(int integer) {
		ostringstream o;
		o << "Query #";
		o << integer;
		return o.str();
	}
}
#endif /*CCBRENGINE_H_*/

