#ifndef DIALOGUESYSTEM_H_
#define DIALOGUESYSTEM_H_

#include "../tcbr/Case.h"
#include "../tcbr/Feature.h"
#include "../tcbr/CaseBase.h"
#include "../tcbr/SimilarityMeasure.h"
#include "../tcbr/CaseRetriever.h"

using namespace std;
using namespace TCBR_Representation;

namespace CCBR_Module{

	class CcbrEngine;

	class DialogueSystem{
	protected:
		CaseBase* applicationCaseBase_;
		CaseBase* dialogueCaseBase_;
		Case* currentSession_;
		Case* currentAppCase_;
		int sessionNumber_;
		int currentPosition_;
		double similarityThreshold_;

		Case* retrieve();
		bool retain();

	public:
		DialogueSystem(CaseBase* applicationCaseBase, double similarityThreshold);
		virtual ~DialogueSystem();

		void newSession(Case* initialAppCase);
		void reuseDialogue(vector<pair<Case*, double> >* solutions, vector<pair<string, double> >* questions);
		void addFeature(string featureType);

		void discardSession();
		bool commitSession(Case* applicationCase);

		int getNumberOfStoredDialogues();
	};

	inline string convertToString(int integer) {
		ostringstream o;
		o << integer;
		return o.str();
	};

	inline int convertToInt(string s)	{
		istringstream i(s);
		int x;
		i >> x;
		return x;
	};

	inline string generateDialogueId(int integer) {
		ostringstream o;
		o << "Dialogue #";
		o << integer;
		return o.str();
	};
};

#endif /*DIALOGUESYSTEM_H_*/
