#ifndef FEATURERANKER_H_
#define FEATURERANKER_H_

#include <string>
#include <set>
#include <vector>
#include "../tcbr/Feature.h"
#include "../tcbr/Case.h"
#include "../tcbr/CaseBase.h"
#include "../tcbr/SimilarityMeasure.h"
#include "../tcbr/CaseRetriever.h"

using namespace std;
using namespace TCBR_Representation;

namespace CCBR_Module{

	class FeatureRanker{
		public:
			FeatureRanker(CaseBase* caseBase, string solutionFeature);
			virtual ~FeatureRanker();
			void rankFeatures();

		protected:
			CaseBase* caseBase_;
			string solutionFeature_;
			map<string, double> weights_;

			void normalizeWeights();
			void updateMatchingFeatures(Case* c1, Case* c2, double deltaWeight);
			void processCase(Case* c, SimilarityMeasureCaseRetriever* crsc, double deltaWeight);

	};

}

#endif /*FEATURERANKER_H_*/
