#ifndef INFORMATIONGAIN_H_
#define INFORMATIONGAIN_H_

#include <vector>
#include <string>
#include <math.h>
//#include <algorithm>
#include "../tcbr/Case.h"
#include "../tcbr/CaseBase.h"

using namespace std;
using namespace TCBR_Representation;

struct featurepair
{
	bool operator()(const pair<Entity*, double>& a, const pair<Entity*, double>& b) const {
		return a.second > b.second;
	}
};

namespace CCBR_Module
{
	class InformationGain	{
		public:
			InformationGain();
			virtual ~InformationGain();
			vector<pair<Entity*, double> > InformationGain::rankFeatures(Case* query, string classification, vector<pair<Case*, double> > caseSimilarities,CaseBase* cb);

		protected:
			double calculateInformationGain(double entropy, string feature, string cFeature, vector<pair<Case*, double> > sim, CaseBase* cb);
			double calculateReduction(string feature, string cFeature, vector<pair<Case*, double> > sim, CaseBase* cb);
			double calculateEntropy(string cFeature, vector<pair<Case*, double> > sim, CaseBase* cb);
	};
}

#endif /*INFORMATIONGAIN_H_*/
