#ifndef CASEBASE_H_
#define CASEBASE_H_

#include <string>
#include <cmath>
#include <set>
#include <utility>

#include "KnowledgeModel.h"
#include "Case.h"
#include "Feature.h"

namespace TCBR_Representation
{

class CaseBase: public KnowledgeModel
{
public:
	CaseBase(std::string name);
	virtual ~CaseBase();
	std::set<Case*> getCases();
	std::set<Case*> getActiveCases(); // Ny
	std::set<Entity*> getFeatureTypes(); // Endret
	std::set<Entity*> getFeatureValues(const std::string& feature); //Ida Kokkersvold har lagt til
	void setWeight(const std::string& type, double weight);
	double getWeight(const std::string& type);

};
}

#endif /*CASEBASE_H_*/
