#ifndef CASERETRIEVER_H_
#define CASERETRIEVER_H_

#include <vector>
#include <string>
#include <iostream>

namespace TCBR_Representation
{
	class Case;
	class CaseBase;
	class SimilarityMeasure;
	class DialogueCaseComparator;

	class CaseRetriever
	{
	protected:
		CaseBase* caseBase_;

	public:
		CaseRetriever(CaseBase* caseBase);
		virtual ~CaseRetriever() {}
		virtual std::vector<std::pair<Case*, double> > retrieveSimilarCases(Case* inputCase) = 0;
	};

	class SimilarityMeasureCaseRetriever: public CaseRetriever
	{
	protected:
		SimilarityMeasure* similarityMeasure_;
		double threshold_;
	public:
		SimilarityMeasureCaseRetriever(CaseBase* caseBase, SimilarityMeasure* similarityMeasure, double threshold);
		virtual std::vector<std::pair<Case*, double> > retrieveSimilarCases(Case* inputCase);
	};

	class DialogueCaseRetriever: public SimilarityMeasureCaseRetriever
	{
	protected:
		CaseBase* appCaseBase_;
	public:
		DialogueCaseRetriever(CaseBase* dialogueCaseBase, CaseBase* appCaseBase, DialogueCaseComparator* similarityMeasure, double threshold);
		virtual std::vector<std::pair<Case*, double> > retrieveSimilarCases(Case* inputCase, Case* appInputCase);
	};

};

#endif /*CASERETRIEVER_H_*/
