#ifndef RESULTSET_H_
#define RESULTSET_H_

#include <vector>
#include <map>
#include <string>

#include "Case.h"

namespace TCBR_Representation
{

class ResultSet
{
private:
	std::vector<TCBR_Representation::Case*>* cases_;
	std::map<std::string, float>* similarityMap_;
	float highestSimilarityDegree_;
	float lowestDegreeOfSimilarity_;

public:
	ResultSet();
	virtual ~ResultSet();
	void addCase(Case* c, float degreeOfSimilarity);
	bool hasCase(std::string name);
	std::vector<Case*>* getCases();
	float getSimilarityDegree(std::string);
	float getHighestSimilarityDegree();
	float getLowestSimilarityDegree();
	void printContent();
};
}
#endif /*RESULTSET_H_*/
