#ifndef SIMILARITYMEASURE_H_
#define SIMILARITYMEASURE_H_

#include <vector>
#include <string>
#include <iostream>

namespace TCBR_Representation{

	class SimilarityMeasure	{
		public:
			virtual ~SimilarityMeasure() {}
			virtual double computeCaseSimilarity(Case* from, Case* to) = 0;
	};

	class QueryBiasedSymbolicComparator: public SimilarityMeasure {
		public:
			virtual double computeCaseSimilarity(Case* from, Case* to);
			virtual double getSymbolicDifference(Case* from, Case* to, Entity* type);
	};

	class DialogueCaseComparator: public QueryBiasedSymbolicComparator {
		public:
			virtual double computeCaseSimilarity(Case* query, Case* stored, Case* appQuery, Case* appSolution);
			virtual double getPositionWeight(Case* from, Case* to, Entity* type);
	};

	inline int convertToInt(std::string s) {
		std::istringstream i(s);
		int x;
		i >> x;
		return x;
	}
};

#endif /*SIMILARITYMEASURE_H_*/
