#ifndef CASEBASEGENERATOR_H_
#define CASEBASEGENERATOR_H_

#include <iostream>
#include <sstream>
#include <fstream>
#include <string>
#include <vector>
#include <set>

#include <stdio.h>
#include <string.h>

#include "../tcbr/CaseBase.h"
#include "../tcbr/Case.h"

using namespace std;
using namespace TCBR_Representation;

struct FEATURE {
	string name;
	string value;
};

struct CASE {
   string name;
   vector<FEATURE> features;
};

class CaseBaseGenerator {
	public:
		CaseBaseGenerator(string datafile);
		CaseBaseGenerator(string datafile, bool patc);
		virtual ~CaseBaseGenerator();

		void insertRandom(unsigned int number, CaseBase* cb);
		void insertRandom(unsigned int number, unsigned int from, unsigned int to, CaseBase* cb);
		void insertSelection(unsigned int from, unsigned int to, CaseBase* cb);
		int getCaseNumber();

	protected:
		vector<CASE> cases_;
		vector<int> positions_;
};

inline string generateCaseId(int integer) {
	ostringstream o;
	o << "Case #";
	o << integer;
	return o.str();
};

#endif /*CASEBASEGENERATOR_H_*/
